import 'package:adeptarch/src/filters/filter.dart';
import 'package:adeptarch/src/utils/sort_mode.dart';
import 'package:json_annotation/json_annotation.dart';
import 'package:flutter/foundation.dart';

part 'number_filter.g.dart';

@JsonSerializable()
class NumberFilter extends Filter<NumberFilter, num>
{
  NumberFilter(
    {
      @required String param,
      SortMode sortMode,
      FilterActionType filterActionType,
    })
      : super(
      param: param,
      sortMode: sortMode,
      filterActionType: filterActionType,
    );

  @override
  bool get isReady {
    if(!isValid) return false;
    if(param != null && paramAction == null && value == null && sortMode == null) return false;
    return true;
  }

  @override
  bool get isValid {
    if(param == null) return false;
    if(param != null && paramAction != null && value == null) return false;
    if(param != null && paramAction == null && value != null) return false;
    return true;
  }

  NumberFilter greaterOrEqualThan(int value) => action(value, FilterActions.GREATER_OR_EQUAL_THAN);
  NumberFilter greaterThan(int value) => action(value, FilterActions.GREATER_THAN);
  NumberFilter lessOrEqualThan(int value) => action(value, FilterActions.LESS_OR_EQUAL_THAN);
  NumberFilter lessThan(int value) => action(value, FilterActions.LESS_THAN);

  @override
  Map<String, dynamic> toJson() => _$NumberFilterToJson(this);
  @override
  NumberFilter fromJsonMap(Map<String, dynamic> json) => NumberFilter.fromJson(json);
  factory NumberFilter.fromJson(Map<String, dynamic> json) => json != null ? _$NumberFilterFromJson(json) : null;
}